// Oleg Petruny proprietary.

#pragma once

#include "Minigame/Minigame.h"

#include "AgeOfWarManager.generated.h"

UCLASS(Blueprintable, BlueprintType, MinimalAPI)
class AAgeOfWarManager : public AMinigame
{
    GENERATED_BODY()

public:
    static const struct FAgeOfWarUnitStats& UnitGetStats(TSubclassOf<AAgeOfWarUnit> unitClass);

    AAgeOfWarManager();

    virtual void Start(class APlayerBase* playerPawn, FMinigameEndCallback delegate) override;
    virtual void End() override;

    void UnitKill(class AAgeOfWarUnit* unit);

protected:
    UFUNCTION(BlueprintImplementableEvent)
    void FillUnitStats();

    UFUNCTION(BlueprintCallable)
    static void AddUnitStats(TSubclassOf<AAgeOfWarUnit> unitClass, struct FAgeOfWarUnitStats stats);

    static TMap<UClass*, struct FAgeOfWarUnitStats> unitStats;

    UPROPERTY(EditAnywhere)
    class UCameraComponent* camera;

    UPROPERTY(EditDefaultsOnly)
    class TSubclassOf<AAgeOfWarUnit> baseClass;
    UPROPERTY(EditAnywhere)
    class AAgeOfWarUnit* basePlayer;
    UPROPERTY(EditAnywhere)
    class AAgeOfWarUnit* baseComputer;



};
